diff --git a/src/main/java/com/facadecode/spring/security/service/UserService.java b/src/main/java/com/facadecode/spring/security/service/UserService.java
index ac2a4af..8a2a626 100644
--- a/src/main/java/com/facadecode/spring/security/service/UserService.java
+++ b/src/main/java/com/facadecode/spring/security/service/UserService.java
@@ -6,6 +6,7 @@ import com.facadecode.spring.security.enums.RoleEnum;
 import com.facadecode.spring.security.repo.AppRoleRepository;
 import com.facadecode.spring.security.repo.AppUserRepository;
 import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.security.access.prepost.PostAuthorize;
 import org.springframework.security.access.prepost.PreAuthorize;
 import org.springframework.stereotype.Service;
 
@@ -45,14 +46,16 @@ public class UserService {
     }
 
     @PreAuthorize(Authority.VIEW_PROFILE)
+    @PostAuthorize("returnObject.username == authentication.name")
     public AppUser get(Long userId) {
         return appUserRepository.findById(userId)
-                .orElse(null);
+                .orElseThrow(() -> new RuntimeException(String.format("User with id %s not found", userId)));
     }
 
     @PreAuthorize(Authority.VIEW_PROFILE)
+    @PostAuthorize("returnObject.username == authentication.name")
     public AppUser get(String username) {
         return appUserRepository.findByUsername(username)
-                .orElse(null);
+                .orElseThrow(() -> new RuntimeException(String.format("User with username %s not found", username)));
     }
 }
